<h1 id="model-basics">Model Basics</h1>
<p>In this tutorial you will learn what models are in Sequelize and how to use them.</p>
<h2 id="concept">Concept</h2>
<p>Models are the essence of Sequelize. A model is an abstraction that represents a table in your database. In Sequelize, it is a class that extends <a href="../class/lib/model.js~Model.html">Model</a>.</p>
<p>The model tells Sequelize several things about the entity it represents, such as the name of the table in the database and which columns it has (and their data types).</p>
<p>A model in Sequelize has a name. This name does not have to be the same name of the table it represents in the database. Usually, models have singular names (such as <code>User</code>) while tables have pluralized names (such as <code>Users</code>), although this is fully configurable.</p>
<h2 id="model-definition">Model Definition</h2>
<p>Models can be defined in two equivalent ways in Sequelize:</p>
<ul>
<li>Calling <a href="../class/lib/sequelize.js~Sequelize.html#instance-method-define"><code>sequelize.define(modelName, attributes, options)</code></a></li>
<li>Extending <a href="../class/lib/model.js~Model.html">Model</a> and calling <a href="../class/lib/model.js~Model.html#static-method-init"><code>init(attributes, options)</code></a></li>
</ul>
<p>After a model is defined, it is available within <code>sequelize.models</code> by its model name.</p>
<p>To learn with an example, we will consider that we want to create a model to represent users, which have a <code>firstName</code> and a <code>lastName</code>. We want our model to be called <code>User</code>, and the table it represents is called <code>Users</code> in the database.</p>
<p>Both ways to define this model are shown below. After being defined, we can access our model with <code>sequelize.models.User</code>.</p>
<h3 id="using-sequelize.define">Using <a href="../class/lib/sequelize.js~Sequelize.html#instance-method-define"><code>sequelize.define</code></a>:</h3>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">const</span> <span class="op">{</span> Sequelize<span class="op">,</span> DataTypes <span class="op">}</span> <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;sequelize&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">const</span> sequelize <span class="op">=</span> <span class="kw">new</span> <span class="at">Sequelize</span>(<span class="st">&#39;sqlite::memory:&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="kw">const</span> User <span class="op">=</span> <span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-5" title="5">  <span class="co">// Model attributes are defined here</span></a>
<a class="sourceLine" id="cb1-6" title="6">  <span class="dt">firstName</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-7" title="7">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-8" title="8">    <span class="dt">allowNull</span><span class="op">:</span> <span class="kw">false</span></a>
<a class="sourceLine" id="cb1-9" title="9">  <span class="op">},</span></a>
<a class="sourceLine" id="cb1-10" title="10">  <span class="dt">lastName</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-11" title="11">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span></a>
<a class="sourceLine" id="cb1-12" title="12">    <span class="co">// allowNull defaults to true</span></a>
<a class="sourceLine" id="cb1-13" title="13">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-14" title="14"><span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-15" title="15">  <span class="co">// Other model options go here</span></a>
<a class="sourceLine" id="cb1-16" title="16"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-17" title="17"></a>
<a class="sourceLine" id="cb1-18" title="18"><span class="co">// `sequelize.define` also returns the model</span></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="va">console</span>.<span class="at">log</span>(User <span class="op">===</span> <span class="va">sequelize</span>.<span class="va">models</span>.<span class="at">User</span>)<span class="op">;</span> <span class="co">// true</span></a></code></pre></div>
<h3 id="extending-model">Extending <a href="../class/lib/model.js~Model.html">Model</a></h3>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">const</span> <span class="op">{</span> Sequelize<span class="op">,</span> DataTypes<span class="op">,</span> Model <span class="op">}</span> <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;sequelize&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="kw">const</span> sequelize <span class="op">=</span> <span class="kw">new</span> <span class="at">Sequelize</span>(<span class="st">&#39;sqlite::memory&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="kw">class</span> User <span class="kw">extends</span> Model <span class="op">{}</span></a>
<a class="sourceLine" id="cb2-5" title="5"></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="va">User</span>.<span class="at">init</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb2-7" title="7">  <span class="co">// Model attributes are defined here</span></a>
<a class="sourceLine" id="cb2-8" title="8">  <span class="dt">firstName</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-9" title="9">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-10" title="10">    <span class="dt">allowNull</span><span class="op">:</span> <span class="kw">false</span></a>
<a class="sourceLine" id="cb2-11" title="11">  <span class="op">},</span></a>
<a class="sourceLine" id="cb2-12" title="12">  <span class="dt">lastName</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-13" title="13">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span></a>
<a class="sourceLine" id="cb2-14" title="14">    <span class="co">// allowNull defaults to true</span></a>
<a class="sourceLine" id="cb2-15" title="15">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-16" title="16"><span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-17" title="17">  <span class="co">// Other model options go here</span></a>
<a class="sourceLine" id="cb2-18" title="18">  sequelize<span class="op">,</span> <span class="co">// We need to pass the connection instance</span></a>
<a class="sourceLine" id="cb2-19" title="19">  <span class="dt">modelName</span><span class="op">:</span> <span class="st">&#39;User&#39;</span> <span class="co">// We need to choose the model name</span></a>
<a class="sourceLine" id="cb2-20" title="20"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-21" title="21"></a>
<a class="sourceLine" id="cb2-22" title="22"><span class="co">// the defined model is the class itself</span></a>
<a class="sourceLine" id="cb2-23" title="23"><span class="va">console</span>.<span class="at">log</span>(User <span class="op">===</span> <span class="va">sequelize</span>.<span class="va">models</span>.<span class="at">User</span>)<span class="op">;</span> <span class="co">// true</span></a></code></pre></div>
<p>Internally, <code>sequelize.define</code> calls <code>Model.init</code>, so both approaches are essentially equivalent.</p>
<h2 id="table-name-inference">Table name inference</h2>
<p>Observe that, in both methods above, the table name (<code>Users</code>) was never explicitly defined. However, the model name was given (<code>User</code>).</p>
<p>By default, when the table name is not given, Sequelize automatically pluralizes the model name and uses that as the table name. This pluralization is done under the hood by a library called <a href="https://www.npmjs.com/package/inflection">inflection</a>, so that irregular plurals (such as <code>person -&gt; people</code>) are computed correctly.</p>
<p>Of course, this behavior is easily configurable.</p>
<h3 id="enforcing-the-table-name-to-be-equal-to-the-model-name">Enforcing the table name to be equal to the model name</h3>
<p>You can stop the auto-pluralization performed by Sequelize using the <code>freezeTableName: true</code> option. This way, Sequelize will infer the table name to be equal to the model name, without any modifications:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="co">// ... (attributes)</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-4" title="4">  <span class="dt">freezeTableName</span><span class="op">:</span> <span class="kw">true</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>The example above will create a model named <code>User</code> pointing to a table also named <code>User</code>.</p>
<p>This behavior can also be defined globally for the sequelize instance, when it is created:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">const</span> sequelize <span class="op">=</span> <span class="kw">new</span> <span class="at">Sequelize</span>(<span class="st">&#39;sqlite::memory:&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="dt">define</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-3" title="3">    <span class="dt">freezeTableName</span><span class="op">:</span> <span class="kw">true</span></a>
<a class="sourceLine" id="cb4-4" title="4">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>This way, all tables will use the same name as the model name.</p>
<h3 id="providing-the-table-name-directly">Providing the table name directly</h3>
<p>You can simply tell Sequelize the name of the table directly as well:</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="co">// ... (attributes)</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-4" title="4">  <span class="dt">tableName</span><span class="op">:</span> <span class="st">&#39;Employees&#39;</span></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h2 id="model-synchronization">Model synchronization</h2>
<p>When you define a model, you’re telling Sequelize a few things about its table in the database. However, what if the table actually doesn’t even exist in the database? What if it exists, but it has different columns, less columns, or any other difference?</p>
<p>This is where model synchronization comes in. A model can be synchronized with the database by calling <a href="https://sequelize.org/master/class/lib/model.js~Model.html#static-method-sync"><code>model.sync(options)</code></a>, an asynchronous function (that returns a Promise). With this call, Sequelize will automatically perform an SQL query to the database. Note that this changes only the table in the database, not the model in the JavaScript side.</p>
<ul>
<li><code>User.sync()</code> - This creates the table if it doesn’t exist (and does nothing if it already exists)</li>
<li><code>User.sync({ force: true })</code> - This creates the table, dropping it first if it already existed</li>
<li><code>User.sync({ alter: true })</code> - This checks what is the current state of the table in the database (which columns it has, what are their data types, etc), and then performs the necessary changes in the table to make it match the model.</li>
</ul>
<p>Example:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="cf">await</span> <span class="va">User</span>.<span class="at">sync</span>(<span class="op">{</span> <span class="dt">force</span><span class="op">:</span> <span class="kw">true</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;The table for the User model was just (re)created!&quot;</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="synchronizing-all-models-at-once">Synchronizing all models at once</h3>
<p>You can use <a href="../class/lib/sequelize.js~Sequelize.html#instance-method-sync"><code>sequelize.sync()</code></a> to automatically synchronize all models. Example:</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="cf">await</span> <span class="va">sequelize</span>.<span class="at">sync</span>(<span class="op">{</span> <span class="dt">force</span><span class="op">:</span> <span class="kw">true</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-2" title="2"><span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;All models were synchronized successfully.&quot;</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="dropping-tables">Dropping tables</h3>
<p>To drop the table related to a model:</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="cf">await</span> <span class="va">User</span>.<span class="at">drop</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;User table dropped!&quot;</span>)<span class="op">;</span></a></code></pre></div>
<p>To drop all tables:</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="cf">await</span> <span class="va">sequelize</span>.<span class="at">drop</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;All tables dropped!&quot;</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="database-safety-check">Database safety check</h3>
<p>As shown above, the <code>sync</code> and <code>drop</code> operations are destructive. Sequelize acceps a <code>match</code> option as an additional safety check, which receives a RegExp:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="co">// This will run .sync() only if database name ends with &#39;_test&#39;</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="va">sequelize</span>.<span class="at">sync</span>(<span class="op">{</span> <span class="dt">force</span><span class="op">:</span> <span class="kw">true</span><span class="op">,</span> <span class="dt">match</span><span class="op">:</span> <span class="ss">/_test</span><span class="sc">$</span><span class="ss">/</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="synchronization-in-production">Synchronization in production</h3>
<p>As shown above, <code>sync({ force: true })</code> and <code>sync({ alter: true })</code> can be destructive operations. Therefore, they are not recommended for production-level software. Instead, synchronization should be done with the advanced concept of <a href="migrations.html">Migrations</a>, with the help of the <a href="https://github.com/sequelize/cli">Sequelize CLI</a>.</p>
<h2 id="timestamps">Timestamps</h2>
<p>By default, Sequelize automatically adds the fields <code>createdAt</code> and <code>updatedAt</code> to every model, using the data type <code>DataTypes.DATE</code>. Those fields are automatically managed as well - whenever you use Sequelize to create or update something, those fields will be set correctly. The <code>createdAt</code> field will contain the timestamp representing the moment of creation, and the <code>updatedAt</code> will contain the timestamp of the latest update.</p>
<p><strong>Note:</strong> This is done in the Sequelize level (i.e. not done with <em>SQL triggers</em>). This means that direct SQL queries (for example queries performed without Sequelize by any other means) will not cause these fields to be updated automatically.</p>
<p>This behavior can be disabled for a model with the <code>timestamps: false</code> option:</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb11-2" title="2">  <span class="co">// ... (attributes)</span></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb11-4" title="4">  <span class="dt">timestamps</span><span class="op">:</span> <span class="kw">false</span></a>
<a class="sourceLine" id="cb11-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>It is also possible to enable only one of <code>createdAt</code>/<code>updatedAt</code>, and to provide a custom name for these columns:</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">class</span> Foo <span class="kw">extends</span> Model <span class="op">{}</span></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="va">Foo</span>.<span class="at">init</span>(<span class="op">{</span> <span class="co">/* attributes */</span> <span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb12-3" title="3">  sequelize<span class="op">,</span></a>
<a class="sourceLine" id="cb12-4" title="4"></a>
<a class="sourceLine" id="cb12-5" title="5">  <span class="co">// don&#39;t forget to enable timestamps!</span></a>
<a class="sourceLine" id="cb12-6" title="6">  <span class="dt">timestamps</span><span class="op">:</span> <span class="kw">true</span><span class="op">,</span></a>
<a class="sourceLine" id="cb12-7" title="7"></a>
<a class="sourceLine" id="cb12-8" title="8">  <span class="co">// I don&#39;t want createdAt</span></a>
<a class="sourceLine" id="cb12-9" title="9">  <span class="dt">createdAt</span><span class="op">:</span> <span class="kw">false</span><span class="op">,</span></a>
<a class="sourceLine" id="cb12-10" title="10"></a>
<a class="sourceLine" id="cb12-11" title="11">  <span class="co">// I want updatedAt to actually be called updateTimestamp</span></a>
<a class="sourceLine" id="cb12-12" title="12">  <span class="dt">updatedAt</span><span class="op">:</span> <span class="st">&#39;updateTimestamp&#39;</span></a>
<a class="sourceLine" id="cb12-13" title="13"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h2 id="column-declaration-shorthand-syntax">Column declaration shorthand syntax</h2>
<p>If the only thing being specified about a column is its data type, the syntax can be shortened:</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1"><span class="co">// This:</span></a>
<a class="sourceLine" id="cb13-2" title="2"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb13-3" title="3">  <span class="dt">name</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb13-4" title="4">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span></a>
<a class="sourceLine" id="cb13-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb13-6" title="6"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb13-7" title="7"></a>
<a class="sourceLine" id="cb13-8" title="8"><span class="co">// Can be simplified to:</span></a>
<a class="sourceLine" id="cb13-9" title="9"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="dt">name</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h2 id="default-values">Default Values</h2>
<p>By default, Sequelize assumes that the default value of a column is <code>NULL</code>. This behavior can be changed by passing a specific <code>defaultValue</code> to the column definition:</p>
<div class="sourceCode" id="cb14"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;User&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb14-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb14-3" title="3">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span></a>
<a class="sourceLine" id="cb14-4" title="4">    <span class="dt">defaultValue</span><span class="op">:</span> <span class="st">&quot;John Doe&quot;</span></a>
<a class="sourceLine" id="cb14-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb14-6" title="6"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>Some special values, such as <code>Sequelize.NOW</code>, are also accepted:</p>
<div class="sourceCode" id="cb15"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;Foo&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb15-2" title="2">  <span class="dt">bar</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb15-3" title="3">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">DATETIME</span><span class="op">,</span></a>
<a class="sourceLine" id="cb15-4" title="4">    <span class="dt">defaultValue</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="at">NOW</span></a>
<a class="sourceLine" id="cb15-5" title="5">    <span class="co">// This way, the current date/time will be used to populate this column (at the moment of insertion)</span></a>
<a class="sourceLine" id="cb15-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb15-7" title="7"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h2 id="data-types">Data Types</h2>
<p>Every column you define in your model must have a data type. Sequelize provides <a href="https://github.com/sequelize/sequelize/blob/master/lib/data-types.js">a lot of built-in data types</a>. To access a built-in data type, you must import <code>DataTypes</code>:</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1"><span class="kw">const</span> <span class="op">{</span> DataTypes <span class="op">}</span> <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;sequelize&quot;</span>)<span class="op">;</span> <span class="co">// Import the built-in data types</span></a></code></pre></div>
<h3 id="strings">Strings</h3>
<div class="sourceCode" id="cb17"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb17-1" title="1"><span class="va">DataTypes</span>.<span class="at">STRING</span>             <span class="co">// VARCHAR(255)</span></a>
<a class="sourceLine" id="cb17-2" title="2"><span class="va">DataTypes</span>.<span class="at">STRING</span>(<span class="dv">1234</span>)       <span class="co">// VARCHAR(1234)</span></a>
<a class="sourceLine" id="cb17-3" title="3"><span class="va">DataTypes</span>.<span class="va">STRING</span>.<span class="at">BINARY</span>      <span class="co">// VARCHAR BINARY</span></a>
<a class="sourceLine" id="cb17-4" title="4"><span class="va">DataTypes</span>.<span class="at">TEXT</span>               <span class="co">// TEXT</span></a>
<a class="sourceLine" id="cb17-5" title="5"><span class="va">DataTypes</span>.<span class="at">TEXT</span>(<span class="st">&#39;tiny&#39;</span>)       <span class="co">// TINYTEXT</span></a>
<a class="sourceLine" id="cb17-6" title="6"><span class="va">DataTypes</span>.<span class="at">CITEXT</span>             <span class="co">// CITEXT          PostgreSQL and SQLite only.</span></a></code></pre></div>
<h3 id="boolean">Boolean</h3>
<div class="sourceCode" id="cb18"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb18-1" title="1"><span class="va">DataTypes</span>.<span class="at">BOOLEAN</span>            <span class="co">// TINYINT(1)</span></a></code></pre></div>
<h3 id="numbers">Numbers</h3>
<div class="sourceCode" id="cb19"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb19-1" title="1"><span class="va">DataTypes</span>.<span class="at">INTEGER</span>            <span class="co">// INTEGER</span></a>
<a class="sourceLine" id="cb19-2" title="2"><span class="va">DataTypes</span>.<span class="at">BIGINT</span>             <span class="co">// BIGINT</span></a>
<a class="sourceLine" id="cb19-3" title="3"><span class="va">DataTypes</span>.<span class="at">BIGINT</span>(<span class="dv">11</span>)         <span class="co">// BIGINT(11)</span></a>
<a class="sourceLine" id="cb19-4" title="4"></a>
<a class="sourceLine" id="cb19-5" title="5"><span class="va">DataTypes</span>.<span class="at">FLOAT</span>              <span class="co">// FLOAT</span></a>
<a class="sourceLine" id="cb19-6" title="6"><span class="va">DataTypes</span>.<span class="at">FLOAT</span>(<span class="dv">11</span>)          <span class="co">// FLOAT(11)</span></a>
<a class="sourceLine" id="cb19-7" title="7"><span class="va">DataTypes</span>.<span class="at">FLOAT</span>(<span class="dv">11</span><span class="op">,</span> <span class="dv">10</span>)      <span class="co">// FLOAT(11,10)</span></a>
<a class="sourceLine" id="cb19-8" title="8"></a>
<a class="sourceLine" id="cb19-9" title="9"><span class="va">DataTypes</span>.<span class="at">REAL</span>               <span class="co">// REAL            PostgreSQL only.</span></a>
<a class="sourceLine" id="cb19-10" title="10"><span class="va">DataTypes</span>.<span class="at">REAL</span>(<span class="dv">11</span>)           <span class="co">// REAL(11)        PostgreSQL only.</span></a>
<a class="sourceLine" id="cb19-11" title="11"><span class="va">DataTypes</span>.<span class="at">REAL</span>(<span class="dv">11</span><span class="op">,</span> <span class="dv">12</span>)       <span class="co">// REAL(11,12)     PostgreSQL only.</span></a>
<a class="sourceLine" id="cb19-12" title="12"></a>
<a class="sourceLine" id="cb19-13" title="13"><span class="va">DataTypes</span>.<span class="at">DOUBLE</span>             <span class="co">// DOUBLE</span></a>
<a class="sourceLine" id="cb19-14" title="14"><span class="va">DataTypes</span>.<span class="at">DOUBLE</span>(<span class="dv">11</span>)         <span class="co">// DOUBLE(11)</span></a>
<a class="sourceLine" id="cb19-15" title="15"><span class="va">DataTypes</span>.<span class="at">DOUBLE</span>(<span class="dv">11</span><span class="op">,</span> <span class="dv">10</span>)     <span class="co">// DOUBLE(11,10)</span></a>
<a class="sourceLine" id="cb19-16" title="16"></a>
<a class="sourceLine" id="cb19-17" title="17"><span class="va">DataTypes</span>.<span class="at">DECIMAL</span>            <span class="co">// DECIMAL</span></a>
<a class="sourceLine" id="cb19-18" title="18"><span class="va">DataTypes</span>.<span class="at">DECIMAL</span>(<span class="dv">10</span><span class="op">,</span> <span class="dv">2</span>)     <span class="co">// DECIMAL(10,2)</span></a></code></pre></div>
<h4 id="unsigned-zerofill-integers---mysqlmariadb-only">Unsigned &amp; Zerofill integers - MySQL/MariaDB only</h4>
<p>In MySQL and MariaDB, the data types <code>INTEGER</code>, <code>BIGINT</code>, <code>FLOAT</code> and <code>DOUBLE</code> can be set as unsigned or zerofill (or both), as follows:</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb20-1" title="1"><span class="va">DataTypes</span>.<span class="va">INTEGER</span>.<span class="at">UNSIGNED</span></a>
<a class="sourceLine" id="cb20-2" title="2"><span class="va">DataTypes</span>.<span class="va">INTEGER</span>.<span class="at">ZEROFILL</span></a>
<a class="sourceLine" id="cb20-3" title="3"><span class="va">DataTypes</span>.<span class="va">INTEGER</span>.<span class="va">UNSIGNED</span>.<span class="at">ZEROFILL</span></a>
<a class="sourceLine" id="cb20-4" title="4"><span class="co">// You can also specify the size i.e. INTEGER(10) instead of simply INTEGER</span></a>
<a class="sourceLine" id="cb20-5" title="5"><span class="co">// Same for BIGINT, FLOAT and DOUBLE</span></a></code></pre></div>
<h3 id="dates">Dates</h3>
<div class="sourceCode" id="cb21"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb21-1" title="1"><span class="va">DataTypes</span>.<span class="at">DATE</span>       <span class="co">// DATETIME for mysql / sqlite, TIMESTAMP WITH TIME ZONE for postgres</span></a>
<a class="sourceLine" id="cb21-2" title="2"><span class="va">DataTypes</span>.<span class="at">DATE</span>(<span class="dv">6</span>)    <span class="co">// DATETIME(6) for mysql 5.6.4+. Fractional seconds support with up to 6 digits of precision</span></a>
<a class="sourceLine" id="cb21-3" title="3"><span class="va">DataTypes</span>.<span class="at">DATEONLY</span>   <span class="co">// DATE without time</span></a></code></pre></div>
<h3 id="uuids">UUIDs</h3>
<p>For UUIDs, use <code>DataTypes.UUID</code>. It becomes the <code>UUID</code> data type for PostgreSQL and SQLite, and <code>CHAR(36)</code> for MySQL. Sequelize can generate UUIDs automatically for these fields, simply use <code>Sequelize.UUIDV1</code> or <code>Sequelize.UUIDV4</code> as the default value:</p>
<div class="sourceCode" id="cb22"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb22-1" title="1"><span class="op">{</span></a>
<a class="sourceLine" id="cb22-2" title="2">  <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">UUID</span><span class="op">,</span></a>
<a class="sourceLine" id="cb22-3" title="3">  <span class="dt">defaultValue</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="at">UUIDV4</span> <span class="co">// Or Sequelize.UUIDV1</span></a>
<a class="sourceLine" id="cb22-4" title="4"><span class="op">}</span></a></code></pre></div>
<h3 id="others">Others</h3>
<p>There are other data types, covered in a <a href="other-data-types.html">separate guide</a>.</p>
<h2 id="column-options">Column Options</h2>
<p>When defining a column, apart from specifying the <code>type</code> of the column, and the <code>allowNull</code> and <code>defaultValue</code> options mentioned above, there are a lot more options that can be used. Some examples are below.</p>
<div class="sourceCode" id="cb23"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb23-1" title="1"><span class="kw">const</span> <span class="op">{</span> Model<span class="op">,</span> DataTypes<span class="op">,</span> Deferrable <span class="op">}</span> <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;sequelize&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb23-2" title="2"></a>
<a class="sourceLine" id="cb23-3" title="3"><span class="kw">class</span> Foo <span class="kw">extends</span> Model <span class="op">{}</span></a>
<a class="sourceLine" id="cb23-4" title="4"><span class="va">Foo</span>.<span class="at">init</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb23-5" title="5">  <span class="co">// instantiating will automatically set the flag to true if not set</span></a>
<a class="sourceLine" id="cb23-6" title="6">  <span class="dt">flag</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">BOOLEAN</span><span class="op">,</span> <span class="dt">allowNull</span><span class="op">:</span> <span class="kw">false</span><span class="op">,</span> <span class="dt">defaultValue</span><span class="op">:</span> <span class="kw">true</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-7" title="7"></a>
<a class="sourceLine" id="cb23-8" title="8">  <span class="co">// default values for dates =&gt; current time</span></a>
<a class="sourceLine" id="cb23-9" title="9">  <span class="dt">myDate</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">DATE</span><span class="op">,</span> <span class="dt">defaultValue</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">NOW</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-10" title="10"></a>
<a class="sourceLine" id="cb23-11" title="11">  <span class="co">// setting allowNull to false will add NOT NULL to the column, which means an error will be</span></a>
<a class="sourceLine" id="cb23-12" title="12">  <span class="co">// thrown from the DB when the query is executed if the column is null. If you want to check that a value</span></a>
<a class="sourceLine" id="cb23-13" title="13">  <span class="co">// is not null before querying the DB, look at the validations section below.</span></a>
<a class="sourceLine" id="cb23-14" title="14">  <span class="dt">title</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span> <span class="dt">allowNull</span><span class="op">:</span> <span class="kw">false</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-15" title="15"></a>
<a class="sourceLine" id="cb23-16" title="16">  <span class="co">// Creating two objects with the same value will throw an error. The unique property can be either a</span></a>
<a class="sourceLine" id="cb23-17" title="17">  <span class="co">// boolean, or a string. If you provide the same string for multiple columns, they will form a</span></a>
<a class="sourceLine" id="cb23-18" title="18">  <span class="co">// composite unique key.</span></a>
<a class="sourceLine" id="cb23-19" title="19">  <span class="dt">uniqueOne</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span>  <span class="dt">unique</span><span class="op">:</span> <span class="st">&#39;compositeIndex&#39;</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-20" title="20">  <span class="dt">uniqueTwo</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">INTEGER</span><span class="op">,</span> <span class="dt">unique</span><span class="op">:</span> <span class="st">&#39;compositeIndex&#39;</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-21" title="21"></a>
<a class="sourceLine" id="cb23-22" title="22">  <span class="co">// The unique property is simply a shorthand to create a unique constraint.</span></a>
<a class="sourceLine" id="cb23-23" title="23">  <span class="dt">someUnique</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span> <span class="dt">unique</span><span class="op">:</span> <span class="kw">true</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-24" title="24"></a>
<a class="sourceLine" id="cb23-25" title="25">  <span class="co">// Go on reading for further information about primary keys</span></a>
<a class="sourceLine" id="cb23-26" title="26">  <span class="dt">identifier</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span> <span class="dt">primaryKey</span><span class="op">:</span> <span class="kw">true</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-27" title="27"></a>
<a class="sourceLine" id="cb23-28" title="28">  <span class="co">// autoIncrement can be used to create auto_incrementing integer columns</span></a>
<a class="sourceLine" id="cb23-29" title="29">  <span class="dt">incrementMe</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">INTEGER</span><span class="op">,</span> <span class="dt">autoIncrement</span><span class="op">:</span> <span class="kw">true</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-30" title="30"></a>
<a class="sourceLine" id="cb23-31" title="31">  <span class="co">// You can specify a custom column name via the &#39;field&#39; attribute:</span></a>
<a class="sourceLine" id="cb23-32" title="32">  <span class="dt">fieldWithUnderscores</span><span class="op">:</span> <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span> <span class="dt">field</span><span class="op">:</span> <span class="st">&#39;field_with_underscores&#39;</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb23-33" title="33"></a>
<a class="sourceLine" id="cb23-34" title="34">  <span class="co">// It is possible to create foreign keys:</span></a>
<a class="sourceLine" id="cb23-35" title="35">  <span class="dt">bar_id</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb23-36" title="36">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">INTEGER</span><span class="op">,</span></a>
<a class="sourceLine" id="cb23-37" title="37"></a>
<a class="sourceLine" id="cb23-38" title="38">    <span class="dt">references</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb23-39" title="39">      <span class="co">// This is a reference to another model</span></a>
<a class="sourceLine" id="cb23-40" title="40">      <span class="dt">model</span><span class="op">:</span> Bar<span class="op">,</span></a>
<a class="sourceLine" id="cb23-41" title="41"></a>
<a class="sourceLine" id="cb23-42" title="42">      <span class="co">// This is the column name of the referenced model</span></a>
<a class="sourceLine" id="cb23-43" title="43">      <span class="dt">key</span><span class="op">:</span> <span class="st">&#39;id&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb23-44" title="44"></a>
<a class="sourceLine" id="cb23-45" title="45">      <span class="co">// With PostgreSQL, it is optionally possible to declare when to check the foreign key constraint, passing the Deferrable type.</span></a>
<a class="sourceLine" id="cb23-46" title="46">      <span class="dt">deferrable</span><span class="op">:</span> <span class="va">Deferrable</span>.<span class="at">INITIALLY_IMMEDIATE</span></a>
<a class="sourceLine" id="cb23-47" title="47">      <span class="co">// Options:</span></a>
<a class="sourceLine" id="cb23-48" title="48">      <span class="co">// - `Deferrable.INITIALLY_IMMEDIATE` - Immediately check the foreign key constraints</span></a>
<a class="sourceLine" id="cb23-49" title="49">      <span class="co">// - `Deferrable.INITIALLY_DEFERRED` - Defer all foreign key constraint check to the end of a transaction</span></a>
<a class="sourceLine" id="cb23-50" title="50">      <span class="co">// - `Deferrable.NOT` - Don&#39;t defer the checks at all (default) - This won&#39;t allow you to dynamically change the rule in a transaction</span></a>
<a class="sourceLine" id="cb23-51" title="51">    <span class="op">}</span></a>
<a class="sourceLine" id="cb23-52" title="52">  <span class="op">},</span></a>
<a class="sourceLine" id="cb23-53" title="53"></a>
<a class="sourceLine" id="cb23-54" title="54">  <span class="co">// Comments can only be added to columns in MySQL, MariaDB, PostgreSQL and MSSQL</span></a>
<a class="sourceLine" id="cb23-55" title="55">  <span class="dt">commentMe</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb23-56" title="56">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">INTEGER</span><span class="op">,</span></a>
<a class="sourceLine" id="cb23-57" title="57">    <span class="dt">comment</span><span class="op">:</span> <span class="st">&#39;This is a column name that has a comment&#39;</span></a>
<a class="sourceLine" id="cb23-58" title="58">  <span class="op">}</span></a>
<a class="sourceLine" id="cb23-59" title="59"><span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb23-60" title="60">  sequelize<span class="op">,</span></a>
<a class="sourceLine" id="cb23-61" title="61">  <span class="dt">modelName</span><span class="op">:</span> <span class="st">&#39;foo&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb23-62" title="62"></a>
<a class="sourceLine" id="cb23-63" title="63">  <span class="co">// Using `unique: true` in an attribute above is exactly the same as creating the index in the model&#39;s options:</span></a>
<a class="sourceLine" id="cb23-64" title="64">  <span class="dt">indexes</span><span class="op">:</span> [<span class="op">{</span> <span class="dt">unique</span><span class="op">:</span> <span class="kw">true</span><span class="op">,</span> <span class="dt">fields</span><span class="op">:</span> [<span class="st">&#39;someUnique&#39;</span>] <span class="op">}</span>]</a>
<a class="sourceLine" id="cb23-65" title="65"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h2 id="taking-advantage-of-models-being-classes">Taking advantage of Models being classes</h2>
<p>The Sequelize models are <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Classes">ES6 classes</a>. You can very easily add custom instance or class level methods.</p>
<div class="sourceCode" id="cb24"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb24-1" title="1"><span class="kw">class</span> User <span class="kw">extends</span> Model <span class="op">{</span></a>
<a class="sourceLine" id="cb24-2" title="2">  <span class="kw">static</span> <span class="at">classLevelMethod</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb24-3" title="3">    <span class="cf">return</span> <span class="st">&#39;foo&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb24-4" title="4">  <span class="op">}</span></a>
<a class="sourceLine" id="cb24-5" title="5">  <span class="at">instanceLevelMethod</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb24-6" title="6">    <span class="cf">return</span> <span class="st">&#39;bar&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb24-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb24-8" title="8">  <span class="at">getFullname</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb24-9" title="9">    <span class="cf">return</span> [<span class="kw">this</span>.<span class="at">firstname</span><span class="op">,</span> <span class="kw">this</span>.<span class="at">lastname</span>].<span class="at">join</span>(<span class="st">&#39; &#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb24-10" title="10">  <span class="op">}</span></a>
<a class="sourceLine" id="cb24-11" title="11"><span class="op">}</span></a>
<a class="sourceLine" id="cb24-12" title="12"><span class="va">User</span>.<span class="at">init</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb24-13" title="13">  <span class="dt">firstname</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="at">TEXT</span><span class="op">,</span></a>
<a class="sourceLine" id="cb24-14" title="14">  <span class="dt">lastname</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="at">TEXT</span></a>
<a class="sourceLine" id="cb24-15" title="15"><span class="op">},</span> <span class="op">{</span> sequelize <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb24-16" title="16"></a>
<a class="sourceLine" id="cb24-17" title="17"><span class="va">console</span>.<span class="at">log</span>(<span class="va">User</span>.<span class="at">classLevelMethod</span>())<span class="op">;</span> <span class="co">// &#39;foo&#39;</span></a>
<a class="sourceLine" id="cb24-18" title="18"><span class="kw">const</span> user <span class="op">=</span> <span class="va">User</span>.<span class="at">build</span>(<span class="op">{</span> <span class="dt">firstname</span><span class="op">:</span> <span class="st">&#39;Jane&#39;</span><span class="op">,</span> <span class="dt">lastname</span><span class="op">:</span> <span class="st">&#39;Doe&#39;</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb24-19" title="19"><span class="va">console</span>.<span class="at">log</span>(<span class="va">user</span>.<span class="at">instanceLevelMethod</span>())<span class="op">;</span> <span class="co">// &#39;bar&#39;</span></a>
<a class="sourceLine" id="cb24-20" title="20"><span class="va">console</span>.<span class="at">log</span>(<span class="va">user</span>.<span class="at">getFullname</span>())<span class="op">;</span> <span class="co">// &#39;Jane Doe&#39;</span></a></code></pre></div>
